// **************************************************************************
// * This file is part of the FreeFileSync project. It is distributed under *
// * GNU General Public License: http://www.gnu.org/licenses/gpl.html       *
// * Copyright (C) Zenju (zenju AT gmx DOT de) - All Rights Reserved        *
// **************************************************************************

#include <iostream>
#include <fstream>


int main(int args, char** argv)
{
    if (args > 0)
    {
        std::string outputName = argv[0];
        outputName += ".log";

        std::ofstream output(outputName.c_str(), std::ios_base::app);
        if (!output)
        {
            std::cout << "Error when creating output file!" << std::endl;
            return -1;
        }

        output << argv[0];
        for (int i = 1; i < args; ++i)
        {
            output << " " << argv[i];
        }
        output << std::endl;

        output.close();
    }
    return 0;
}
